/****************************************************************************
 *   Copyright (C) 2004 by Jurij Ivastsuk-Kienbaum                          *
 *   jurij@device-image.de                                                  *
 *                                                                          *
 *   This program is free software; you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by   *
 *   the Free Software Foundation; either version 2 of the License,         *
 *   or (at your option) any later version.                                 *
 *   This program is distributed in the hope that it will be useful,        *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty            *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                *
 *   See the GNU General Public License for more details.                   *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to the Free Software Foundation,*
 *   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA            *
 ***************************************************************************/


#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE
#define _FILE_OFFSET_BITS 64

#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <getopt.h>


#include <sys/types.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <fcntl.h>

#include "zlib.h"

#include "safe_read.h"
#include "safe_write.h"


#include "common_tools.h"

#ifndef MAX_PATH_LEN
#  define MAX_PATH_LEN   1024 /* max pathname length */
#endif


using namespace std;

int do_zsplit(int ifd, int ofd, int level, string path_ifn, string path_ofn, off_t chnk_size);

int do_zsplit(int ifd, int ofd, int level, string path_ifn, string path_ofn);

string get_mult(string pattern);

uInt seek_on_err(int ifd, size_t count);

void usage();

void help();

void close_in_out_files(int ifd, int ofd);

int do_stat(const char *name, struct stat *sbuf);

int do_stat(int fd, struct stat *sbuf);

string av_speed(long time_sec, unsigned long long total_bytes_read);

int treat_file(string iname);

int treat_stdin();
